//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  C'13,13,65'
#property indicator_color2  C'65,13,13'
#property indicator_color3  Ivory
#property indicator_color4  Ivory
#property indicator_width1  10
#property indicator_width2  10
#property indicator_width3  10
#property indicator_width4  10

//
//
//
//
//

extern string TimeFrame    = "current time frame";
extern int    FastEMA      = 26;
extern int    SlowEMA      = 12;
extern int    SignalEMA    =  9;
extern int    Price        = PRICE_CLOSE;

double histUp[];
double histDn[];
double histNa[];
double histNb[];
double macd[];
double signal[];
double colors[];

int    timeFrame;
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,histUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,histDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,histNa); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,histNb); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,macd);
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,colors);
      timeFrame         = stringToTimeFrame(TimeFrame);
      returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);
      indicatorFileName = WindowExpertName();
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double emas[][2];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { histUp[0] = limit+1; return(0); }
         
         //
         //
         //
         //
         //

         if (timeFrame!=Period()) 
         { 
             limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
             for (i=limit;i>=0; i--)
             {
                int y = iBarShift(NULL,timeFrame,Time[i]);
                  histUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"",FastEMA,SlowEMA,SignalEMA,Price,0,y); 
                  histDn[i] = iCustom(NULL,timeFrame,indicatorFileName,"",FastEMA,SlowEMA,SignalEMA,Price,1,y); 
                  histNa[i] = iCustom(NULL,timeFrame,indicatorFileName,"",FastEMA,SlowEMA,SignalEMA,Price,2,y); 
                  histNb[i] = iCustom(NULL,timeFrame,indicatorFileName,"",FastEMA,SlowEMA,SignalEMA,Price,3,y); 
            }                  
            return(0); 
         }
         if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);

   //
   //
   //
   //
   //
   
      double alphaSign = 2.0/(1.0+SignalEMA);
      double alphaFast = 2.0/(1.0+FastEMA);
      double alphaSlow = 2.0/(1.0+SlowEMA);
      double max = WindowPriceMax()*3.0;
      for(i = limit, r=Bars-i-1; i>=0 ; i--,r++)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         if (i>Bars-2)
         {
            emas[r][0] = price;
            emas[r][1] = price;
            macd[i]    = 0;
            signal[i]  = 0;
            continue;
         }

         //
         //
         //
         //
         //
         
         emas[r][0] = emas[r-1][0]+alphaFast*(price-emas[r-1][0]);
         emas[r][1] = emas[r-1][1]+alphaSlow*(price-emas[r-1][1]);
         macd[i]    = emas[r][0]-emas[r][1];
         signal[i]  = signal[i+1]+alphaSign*(macd[i]-signal[i+1]);
         colors[i]  = colors[i+1];
         histUp[i]  = EMPTY_VALUE;
         histDn[i]  = EMPTY_VALUE;
         histNa[i]  = EMPTY_VALUE;
         histNb[i]  = EMPTY_VALUE;
            
            //
            //
            //
            //
            //
            
            if ( macd[i]>signal[i] && macd[i]>0)                                      colors[i] = 1;
            if ( macd[i]<signal[i] && macd[i]<0)                                      colors[i] =-1;
            if ((macd[i]>signal[i] && macd[i]<0) || (macd[i]<signal[i] && macd[i]>0)) colors[i] = 0;  
               if (colors[i] ==-1) { histUp[i] = max; histDn[i] = 0; }
               if (colors[i] == 1) { histDn[i] = max; histUp[i] = 0; }
               if (colors[i] == 0) { histNa[i] = max; histNb[i] = 0; }
   }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}